package com.hzya.frame.plugin.masterData.project.plugin;

import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.base.PluginBaseEntity;
import com.hzya.frame.sysnew.comparison.masterData.service.impl.MasterDataProjectServiceImpl;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * 项目档案(MdmProject)表服务接口
 *
 * @author makejava
 * @since 2024-06-07 18:29:23
 */
public class MdmProjectPluginInitializer extends PluginBaseEntity{
    Logger logger = LoggerFactory.getLogger(MdmProjectPluginInitializer.class);

    @Autowired
    private MasterDataProjectServiceImpl masterDataProjectService;

      @Override
    public void initialize() {
        logger.info(getPluginLabel() + "執行初始化方法initialize()");
    }

    @Override
    public void destroy() {
        logger.info(getPluginLabel() + "執行銷毀方法destroy()");
    }

    @Override
    public String getPluginId() {
        return "MdmProjectPlugin";
    }

    @Override
    public String getPluginName() {
        return "MdmProjectPlugin插件";
    }

    @Override
    public String getPluginLabel() {
        return "MdmProjectPlugin";
    }

    @Override
    public String getPluginType() {
        return "1";
    }
    @Override
    public JsonResultEntity executeBusiness(JSONObject requestJson) {
          try {
              logger.info("=====开始执行主数据档案项目档案同步=======");
              JsonResultEntity jsonResultEntity = masterDataProjectService.queryProjectArchives(requestJson);
              return jsonResultEntity;
          }catch (Exception e){
              logger.info("======执行主数据档案项目档案同步失败:{}",e.getMessage());
              e.printStackTrace();
          }
        return null;
    }
}
