package com.hzya.frame.cbs8.service.impl;

import cn.hutool.core.map.MapBuilder;
import cn.hutool.core.util.StrUtil;
import cn.hutool.http.HttpRequest;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.cbs8.dto.req.PayResultRequestDTO;
import com.hzya.frame.cbs8.dto.res.CbsResponseDTO;
import com.hzya.frame.cbs8.dto.res.PayResponseDTO;
import com.hzya.frame.cbs8.dto.res.PayResultResDTO;
import com.hzya.frame.cbs8.service.ICbs8Service;
import com.hzya.frame.cbs8.util.CBSUtil;
import com.hzya.frame.seeyon.cbs8.entity.PaymentEntity;
import com.hzya.frame.seeyon.cbs8.service.IPaymentService;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.util.List;
import java.util.Map;

/**
 * @Description cbs8接口
 * @Author xiangerlin
 * @Date 2024/6/7 14:44
 **/
@Service
public class Cbs8ServiceImpl implements ICbs8Service {
    @Autowired
    private IPaymentService paymentService;
    @Override
    public PayResponseDTO payApply(PaymentEntity paymentEntity) {
        Map<String, String> headerMap = MapBuilder.<String, String>create(true)
                .put("apiCode", "8000260001")
                .put("publicKey","ZJYA1vBeY1ai53iNmbAEsw6DImjkXGBkdMailxcBdliFC85Ce7eDIk+3zDUT+v578prj")
                .put("secretKey","7Gp6OjHrIaQ6R3tXGPrI4morjQyWL+qu4JJschQnkBRtv26VDgGFVYKOy5kMZfd/j3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")
                .put("appId","800026")
                .build();
        String body = HttpRequest.post("http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface").addHeaders(headerMap).body(JSONObject.toJSONString(paymentEntity)).timeout(60000).execute().body();
        PayResponseDTO payResponseDTO = JSONObject.parseObject(body,PayResponseDTO.class);
        return payResponseDTO;
    }

    /**
     * 通过业务参考号查询交易结果 3.2.6
     *
     * @param resultRequestDTO
     * @return
     * @throws Exception
     */
    @Override
    public List<PayResultResDTO> queryPayResult(PayResultRequestDTO resultRequestDTO) {
        Map<String, String> headerMap = MapBuilder.<String, String>create(true)
                .put("apiCode", "8000260002")
                .put("publicKey","ZJYA1vBeY1ai53iNmbAEsw6DImjkXGBkdMailxcBdliFC85Ce7eDIk+3zDUT+v578prj")
                .put("secretKey","7Gp6OjHrIaQ6R3tXGPrI4morjQyWL+qu4JJschQnkBRtv26VDgGFVYKOy5kMZfd/j3JzOP8MtA1LSGvL+2BWG8c/o7DKi92S4mr3zcGearA=")
                .put("appId","800026")
                .build();
        String body = HttpRequest.post("http://127.0.0.1:9999/kangarooDataCenterV3/entranceController/externalCallInterface").addHeaders(headerMap).body(JSONObject.toJSONString(resultRequestDTO)).timeout(60000).execute().body();
        if (StrUtil.isEmpty(body)){
            CbsResponseDTO cbsResponseDTO = JSONObject.parseObject(body, CbsResponseDTO.class);
            if (CollectionUtils.isNotEmpty(cbsResponseDTO.getData())){
                List<JSONObject> dataList = cbsResponseDTO.getData();
                List<PayResultResDTO> payResultList = CBSUtil.convertJsonArrayToList(dataList, PayResultResDTO.class);
                return payResultList;
            }
        }
        return null;
    }
}
